SystemOrganization addCategory: #'DAO-TP-Changes'!

TestCase subclass: #ChangesTest
	instanceVariableNames: 'diccionarioDeAcciones nombreDelAutor fechaYHoraTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:37'!
algunaUnidadDeTrabajo
	^UnidadDeTrabajoInicial  new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
autorTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:06'!
cambio01
	^1.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:42'!
classAdded: aClass inCategory: aCategoryName 
	(diccionarioDeAcciones at: ClassAdded) value: (ClassAdded class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 13:02'!
classCategoryAdded: unNombreDeCategoria 
	(diccionarioDeAcciones at: CategoryAdded) value: (CategoryAdded categoryName: unNombreDeCategoria).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 03:16'!
classRemoved: aClass fromCategory: aCategoryName
	( diccionarioDeAcciones at: ClassRemoved ) value: (ClassRemoved class: aClass category: aCategoryName).! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 18:48'!
fullName
	^nombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:06'!
fullName: unNombreDelAutor 
	nombreDelAutor := unNombreDelAutor.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:37'!
initialize 
	diccionarioDeAcciones := Dictionary new.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:10'!
now
	^fechaYHoraTest.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:41'!
on: unTipoDeEvento do: aBlockClosure 
	
	diccionarioDeAcciones at: unTipoDeEvento put: aBlockClosure.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:00'!
relojTest
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 18:08'!
setear: aDateAndTime 
	fechaYHoraTest := aDateAndTime.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:55'!
test001LaUnidadDeTrabajoInicialNoSabeResponderElMensajePadre
	| unaUnidadDeTrabajoInicial |
	unaUnidadDeTrabajoInicial := UnidadDeTrabajoInicial new.
	self should: [ unaUnidadDeTrabajoInicial padre ]
			raise:  MessageNotUnderstood 
			withExceptionDo: [ :aMessageNotUnderstood  | aMessageNotUnderstood messageText = '#padre' ]
! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'maxi 9/23/2013 19:07'!
test002UnaUnidadDeTrabajoSeCreaSinCambiosYAbierta
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal newWith: self algunaUnidadDeTrabajo.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.
	
	unaUnidadDeTrabajo := UnidadDeTrabajoInicial new.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty.
	self deny: unaUnidadDeTrabajo estaCerrada.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'Maxii 9/27/2013 15:06'!
test003UnaUnidadDeTrabajoQueRegistraUnCambioNoEstaVacia
	
	| unaUnidadDeTrabajo |
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo registrarCambio: self cambio01.
	self deny: unaUnidadDeTrabajo todosLosCambios isEmpty.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'Maxii 9/27/2013 15:06'!
test004RegistrarUnCambioEnUnidadCerradaLanzaUnaExcepcion
	
	| unaUnidadDeTrabajo |
	
	unaUnidadDeTrabajo := UnidadDeTrabajoReal new.
	unaUnidadDeTrabajo cerrar.

	self should: [ unaUnidadDeTrabajo registrarCambio: self cambio01 ] raise: Error withExceptionDo:  [ :anError | anError messageText  = UnidadDeTrabajoReal noSePuedeRegistrarCambios.
	self assert: unaUnidadDeTrabajo todosLosCambios isEmpty ].

	! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:53'!
test005UnSistemaDeCambiosSeInicializaConUnaUnidadDeTrabajoActivaVacia
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: unSistemaDeCambios unidadActiva todosLosCambios size = 0.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:55'!
test006ElSistemaRegistraElCambioEnLaUnidadActiva
	
	| unSistemaDeCambios unaUnidadDeTrabajo |

	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios registrarCambio: self cambio01.
	unaUnidadDeTrabajo := unSistemaDeCambios unidadActiva. 

	self assert: unaUnidadDeTrabajo todosLosCambios size = 1.
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:55'!
test007ElSistemaAlCerrarLaUnidadActivaNoCreaUnaUnidadNueva
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadActiva estaCerrada .
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.! !

!ChangesTest methodsFor: '01UnidadDeTrabajoTest' stamp: 'SebastianGarbi 9/16/2013 22:54'!
test007UnaunidadDeTrabajoRealConoceASuPadre
	| unaUnidadDeTrabajoPadre unaUnidadDeTrabajo |
	unaUnidadDeTrabajoPadre := self algunaUnidadDeTrabajo.
	unaUnidadDeTrabajo  := UnidadDeTrabajoReal newWith: unaUnidadDeTrabajoPadre.
	self assert: (unaUnidadDeTrabajo padre = unaUnidadDeTrabajoPadre).! !

!ChangesTest methodsFor: '02SistemaDeCambios' stamp: 'SebastinGarbi 9/29/2013 18:55'!
test008ElSistemaAlCerrarLaUnidadActivaSoloTieneUnidadesDeTrabajoCerradas
	
	| unSistemaDeCambios |
	
	unSistemaDeCambios := SistemaDeCambios new.
	
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 1.
	self assert: ( unSistemaDeCambios unidadesDeTrabajo allSatisfy: [ :unaUnidadDeTrabajo | unaUnidadDeTrabajo estaCerrada ] ).! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 23:00'!
test010ElSistemaDebeCrearUnaUnidadCuandoLaActualEsteCerradaYSeRegistreUnCambio
	| unSistemaDeCambios unaInterfaceDeEventosDeEntrada unCambio |

	unaInterfaceDeEventosDeEntrada:= self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
			
	unSistemaDeCambios cerrarUnidadDeTrabajoActiva.
	unCambio := ChangeClassCreated newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unCambio.
	
	self assert: unSistemaDeCambios unidadesDeTrabajo size = 2.
	self assert: unSistemaDeCambios todosLosCambios size = 1! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 23:00'!
test011UnCambioDebeSaberEnQueMomentoFueRealizadoYPorQuien
	
	| unSistemaDeCambios unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ChangeClassCreated newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.

	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = self autorTest fullName ) 
																								and: unRegistroDeCambio fechaYHora = self relojTest now) 
																								and: unRegistroDeCambio cambio affectedClassName = 'ChangesTest')
																								and:  unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'] ).
	! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 23:00'!
test012ElSistemaRegistraLosCambiosDeTipoClassRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ChangeClassRemoved newAffectedClassName: 'ChangesTest' categoryName: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	self assert: ( unSistemaDeCambios todosLosCambios allSatisfy: [ :unRegistroDeCambio | (((unRegistroDeCambio autor = self autorTest fullName ) 
																								and: unRegistroDeCambio fechaYHora = self relojTest now) 
																								and: unRegistroDeCambio cambio affectedClassName = 'ChangesTest')
																								and:  unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'] ).! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 22:46'!
test013ElSistemaRegistraLosCambiosDeTipoClassRecategorized
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ChangeClassRecategorized classAffected: 'ChangesTest' from: 'DAO-TP-Changes-old' to: 'DAO-TP-Changes'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
		self assert: (unRegistroDeCambio cambio oldCategoryName = 'DAO-TP-Changes-old').
		self assert: (unRegistroDeCambio cambio newCategoryName = 'DAO-TP-Changes').
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 22:42'!
test014ElSistemaRegistraLosCambiosDeTipoClassMethodCreated
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ChangeClassMethodCreated onClass: 'ChangesTestClass' selector: 'nombreDelMetodo' protocolo: 'as yet unclassified' codigo: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTestClass').
		self assert: (unRegistroDeCambio cambio nombreSelector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio nombreProtocolo = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio codigo = '^self').	
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 22:42'!
test015ElSistemaRegistraLosCambiosDeTipoClassMethodRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ChangeClassMethodRemoved onClass: 'ChangesTestClass' selector: 'nombreDelMetodo' protocolo: 'as yet unclassified' codigo: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTestClass').
		self assert: (unRegistroDeCambio cambio nombreSelector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio nombreProtocolo = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio codigo = '^self').	
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 22:42'!
test016ElSistemaRegistraLosCambiosDeTipoInstanceMethodCreated
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ChangeInstanceMethodCreated onClass: 'ChangesTest' selector: 'nombreDelMetodo' protocolo: 'as yet unclassified' codigo: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
		self assert: (unRegistroDeCambio cambio nombreSelector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio nombreProtocolo = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio codigo = '^self').	
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 22:42'!
test017ElSistemaRegistraLosCambiosDeTipoInstanceMethodRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada unEvento |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unEvento := ChangeClassMethodRemoved onClass: 'ChangesTestClass' selector: 'nombreDelMetodo' protocolo: 'as yet unclassified' codigo: '^self'.
	unaInterfaceDeEventosDeEntrada handle: unEvento.
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTestClass').
		self assert: (unRegistroDeCambio cambio nombreSelector = 'nombreDelMetodo').
		self assert: (unRegistroDeCambio cambio nombreProtocolo = 'as yet unclassified').
		self assert: (unRegistroDeCambio cambio codigo = '^self').	
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 22:35'!
test018ElSistemaRegistraLosCambiosDeTipoClassCategoryCreated_y_ClassCategoryRemoved
	| unSistemaDeCambios  unaInterfaceDeEventosDeEntrada |

	unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
	unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
	
	unaInterfaceDeEventosDeEntrada handle: (ChangeClassCategoryCreated newName: 'DAO-TP-Changes').
	unaInterfaceDeEventosDeEntrada handle: (ChangeClassCategoryRemoved newName: 'DAO-TP-Changes').
	
	unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
		self assert: (unRegistroDeCambio autor = self autorTest fullName).
		self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
		self assert: (unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes').
		]! !

!ChangesTest methodsFor: '03InterfaceDeEventosDeEntrada' stamp: 'SebastinGarbi 9/29/2013 22:42'!
test900LaIntefazParaLosAnunciosDePharoPuedeHandlearYEnviarUnCambioDeTipoClassCreated

 | systemAnnouncerTest unSistemaDeCambios unaInterfaceDeEventosDeEntrada |
 

 systemAnnouncerTest := self unSystemAnnouncer.
 unaInterfaceDeEventosDeEntrada := self unaInterfaceDeEventosDeEntradaInicializada.
 
 InterfazParaLosAnuncios newWith: systemAnnouncerTest and: unaInterfaceDeEventosDeEntrada.
 
 unSistemaDeCambios := unaInterfaceDeEventosDeEntrada sistemaDeCambios.
 
 systemAnnouncerTest classAdded: ChangesTest inCategory: #'DAO-TP-Changes'.
 
 unSistemaDeCambios todosLosCambios do: [ :unRegistroDeCambio | 
  self assert: (unRegistroDeCambio autor = self autorTest fullName).
  self assert: (unRegistroDeCambio fechaYHora = self relojTest now).
  self assert: (unRegistroDeCambio cambio affectedClassName = 'ChangesTest').
  self assert: (unRegistroDeCambio cambio categoryName = 'DAO-TP-Changes'). 
  ].! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:11'!
tipoDelCambio01
	^'Agregar'.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'maxi 9/26/2013 23:11'!
unSystemAnnouncer
	^self.! !

!ChangesTest methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:43'!
unaInterfaceDeEventosDeEntradaInicializada
	| unAutor unReloj unSistemaDeCambios |
	unReloj := self relojTest.
	unAutor := self autorTest.
	unSistemaDeCambios := SistemaDeCambios new.
	unAutor fullName: 'Seba'.
	unReloj setear: DateAndTime now.
	^InterfaceDeEntradaDelSistemaDeCambios newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj! !

Object subclass: #Change
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!Change class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:33'!
nuevo
	self subclassResponsibility .! !

Change subclass: #ChangeClass
	instanceVariableNames: 'affectedClassName categoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangeClass class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:00'!
newAffectedClassName: unNombreDeClase categoryName: unNombreDeCategoria 
	^self nuevo affectedClassName: unNombreDeClase  categoryName: unNombreDeCategoria.! !

!ChangeClass methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:43'!
affectedClassName
	^ affectedClassName! !

!ChangeClass methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:43'!
affectedClassName: unNombreDeClase categoryName: unNombreDeCategoria 
	affectedClassName := unNombreDeClase.
	categoryName := unNombreDeCategoria.! !

!ChangeClass methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:43'!
categoryName
	^categoryName.! !

ChangeClass subclass: #ChangeClassCreated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangeClassCreated class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:33'!
nuevo
	^self new.! !

ChangeClass subclass: #ChangeClassRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangeClassRemoved class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:33'!
nuevo
	^self new! !

Change subclass: #ChangeClassCategory
	instanceVariableNames: 'categoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangeClassCategory class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:33'!
newName: unNombreDeCategoria
	^self new categoryName: unNombreDeCategoria.
	! !

!ChangeClassCategory methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:36'!
categoryName
	^ categoryName! !

!ChangeClassCategory methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:36'!
categoryName: unNombreDeCategoria
	categoryName := unNombreDeCategoria.! !

ChangeClassCategory subclass: #ChangeClassCategoryCreated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

ChangeClassCategory subclass: #ChangeClassCategoryRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

Change subclass: #ChangeClassRecategorized
	instanceVariableNames: 'affectedClassName newCategoryName oldCategoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangeClassRecategorized class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:46'!
classAffected: unNombreDeClase from: unNombreDeCategoriaVieja to: unNombreDeCategoriaNueva
	^self new affectedClassName: unNombreDeClase fromCategory: unNombreDeCategoriaVieja toCategory: unNombreDeCategoriaNueva.
	! !

!ChangeClassRecategorized methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:44'!
affectedClassName
	^ affectedClassName! !

!ChangeClassRecategorized methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:46'!
affectedClassName: unNombreDeClase fromCategory: unNombreDeCategoriaVieja toCategory: unNombreDeCategoriaNueva.
	affectedClassName := unNombreDeClase.
	oldCategoryName := unNombreDeCategoriaVieja.
	newCategoryName := unNombreDeCategoriaNueva.! !

!ChangeClassRecategorized methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:46'!
newCategoryName
	^ newCategoryName! !

!ChangeClassRecategorized methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:46'!
oldCategoryName
	^ oldCategoryName! !

Change subclass: #ChangeMethod
	instanceVariableNames: 'nombreDeClase nombreSelector nombreProtocolo codigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

ChangeMethod subclass: #ChangeClassMethod
	instanceVariableNames: 'nombreDeClase nombreSelector nombreProtocolo codigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

ChangeClassMethod subclass: #ChangeClassMethodCreated
	instanceVariableNames: 'nombreDeClase nombreSelector nombreProtocolo codigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangeClassMethodCreated class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:34'!
nuevo
	^self new! !

ChangeClassMethod subclass: #ChangeClassMethodRemoved
	instanceVariableNames: 'codigo nombreDeClase nombreSelector nombreProtocolo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangeClassMethodRemoved class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 21:34'!
nuevo
	^self new! !

ChangeMethod subclass: #ChangeInstanceMethod
	instanceVariableNames: 'nombreDeClase nombreSelector nombreProtocolo codigo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

ChangeInstanceMethod subclass: #ChangeInstanceMethodCreated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangeInstanceMethodCreated class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:13'!
nuevo
	^self new! !

ChangeInstanceMethod subclass: #ChangeInstanceMethodRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!ChangeInstanceMethodRemoved class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:13'!
nuevo
	^self new! !

!ChangeMethod class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:12'!
onClass: unNombreDeClase selector: unNombreSelector protocolo: unNombreProtocolo codigo: unCodigo 
	^self nuevo initializeWithClass: unNombreDeClase selector: unNombreSelector protocolo: unNombreProtocolo codigo: unCodigo.! !

!ChangeMethod methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:42'!
affectedClassName
	^ nombreDeClase! !

!ChangeMethod methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:39'!
className
	^ nombreDeClase! !

!ChangeMethod methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:12'!
codigo
	^ codigo! !

!ChangeMethod methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:12'!
initializeWithClass: unNombreDeClase selector: unNombreSelector protocolo: unNombreProtocolo codigo: unCodigo
	nombreDeClase := unNombreDeClase.
	nombreSelector := unNombreSelector.
	nombreProtocolo := unNombreProtocolo.
	codigo := unCodigo.! !

!ChangeMethod methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:12'!
nombreProtocolo
	^ nombreProtocolo! !

!ChangeMethod methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:12'!
nombreSelector
	^ nombreSelector! !

Object subclass: #InterfaceDeEntradaDelSistemaDeCambios
	instanceVariableNames: 'sistemaDeCambios autor reloj'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfaceDeEntradaDelSistemaDeCambios class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
newWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj 
	^self new initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:52'!
agregarCambio: unCambio por: unNombreDeAutor enElMomento: unaFechaYHora 

	sistemaDeCambios registrarCambio: (RegistroDeCambio newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora ).! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:01'!
handle: unCambio 
	self agregarCambio: unCambio por: autor fullName enElMomento: reloj now.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 16:22'!
initializeWith: unSistemaDeCambios andThisAuthor: unAutor andThisClock: unReloj
	sistemaDeCambios := unSistemaDeCambios.
	autor := unAutor.
	reloj := unReloj.! !

!InterfaceDeEntradaDelSistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:39'!
sistemaDeCambios
	^ sistemaDeCambios! !

Object subclass: #InterfazParaLosAnuncios
	instanceVariableNames: 'systemAnnouncer interfazDeEntradaDelSistemaDeCambios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!InterfazParaLosAnuncios class methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 22:48'!
newWith: anAnnouncer and: anInterfaceDeEntradaDelSistemaDeCambios 
	^self new initializeWith: anAnnouncer and: anInterfaceDeEntradaDelSistemaDeCambios.! !

!InterfazParaLosAnuncios methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 23:14'!
initializeWith: anAnnouncer and: unaInterfaceDeEntradaDelSistemaDeCambios 
	systemAnnouncer := anAnnouncer.
	interfazDeEntradaDelSistemaDeCambios := unaInterfaceDeEntradaDelSistemaDeCambios.

	systemAnnouncer on: ClassAdded  do: [ :unEvento | interfazDeEntradaDelSistemaDeCambios handle: (ChangeClassCreated newAffectedClassName: unEvento classAdded name categoryName: unEvento classCategory )].
	! !

Object subclass: #RegistroDeCambio
	instanceVariableNames: 'cambio autor fechaYHora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!RegistroDeCambio class methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:54'!
newWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	^self new initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora.! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
autor
	^ autor! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 18:04'!
cambio
	^ cambio! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:56'!
fechaYHora
	^ fechaYHora! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'Maxii 9/29/2013 17:58'!
initializeWithThischange: unCambio andThisAuthor: unNombreDeAutor atThisTime: unaFechaYHora 
	cambio := unCambio.
	autor := unNombreDeAutor.
	fechaYHora := unaFechaYHora.! !

!RegistroDeCambio methodsFor: 'as yet unclassified' stamp: 'SebastinGarbi 9/29/2013 19:18'!
tipoDeCambio
	^'classRemoved'.! !

Object subclass: #SistemaDeCambios
	instanceVariableNames: 'unidadesDeTrabajoCerradas unidadDeTrabajoActiva'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/24/2013 21:53'!
cerrarUnidadDeTrabajoActiva
	self unidadActiva cerrar.
	^self! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:34'!
initialize 
	unidadesDeTrabajoCerradas := OrderedCollection new.
	unidadDeTrabajoActiva := UnidadDeTrabajoReal new.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/28/2013 21:12'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	
	[ unidadDeTrabajoActiva registrarCambio: unCambio]
		on: UnidadDeTrabajoException
		do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadDeTrabajoActiva.
		unidadesDeTrabajoCerradas  add: unidadDeTrabajoActiva.
		unidadDeTrabajoActiva := nuevaUnidadActiva.
		unidadDeTrabajoActiva registrarCambio: unCambio ].
! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'Maxii 9/27/2013 15:10'!
todosLosCambios
	^self unidadActiva todosLosCambios.! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/16/2013 21:41'!
unidadActiva
	"devuelve la unidad de trabajo activa"
	^unidadDeTrabajoActiva.
	! !

!SistemaDeCambios methodsFor: 'as yet unclassified' stamp: 'maxi 9/9/2013 20:43'!
unidadesDeTrabajo
	|todasLasUnidadesDeTrabajo|
	todasLasUnidadesDeTrabajo := unidadesDeTrabajoCerradas asSet.
	todasLasUnidadesDeTrabajo add: unidadDeTrabajoActiva.
	^todasLasUnidadesDeTrabajo.! !

Object subclass: #UnidadDeTrabajo
	instanceVariableNames: 'cambios cerrada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

UnidadDeTrabajo class
	instanceVariableNames: 'unidadActiva unidadesCerradas'!

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
noSePuedeRegistrarCambios
	^'No se puede registrar cambios en esta unidad de trabajo.'.! !

!UnidadDeTrabajo class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 23:30'!
registrarCambio: unCambio
	| nuevaUnidadActiva |
	[ unidadActiva registrarCambio: unCambio]
	on: Error
	do: [ nuevaUnidadActiva := UnidadDeTrabajoReal newWith: unidadActiva.
		unidadesCerradas add: unidadActiva.
		unidadActiva := nuevaUnidadActiva.
		unidadActiva registrarCambio: unCambio ].
	^self
! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
cerrar
	cerrada := true.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
estaCerrada
	^cerrada.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
initialize
	cambios := OrderedCollection new.
	cerrada := false.
	^self! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/28/2013 15:29'!
registrarCambio: unCambio
	self estaCerrada ifTrue: [ UnidadDeTrabajoException  signal: self class noSePuedeRegistrarCambios]. 
	cambios add: unCambio.
	^self.! !

!UnidadDeTrabajo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:44'!
todosLosCambios
	^cambios.! !

UnidadDeTrabajo subclass: #UnidadDeTrabajoInicial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

UnidadDeTrabajo subclass: #UnidadDeTrabajoReal
	instanceVariableNames: 'padre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!

!UnidadDeTrabajoReal class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:38'!
newWith: unaUnidadDeTrabajo
	^self new initializeWith: unaUnidadDeTrabajo.! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:39'!
initializeWith: unaUnidadDeTrabajo
	padre := unaUnidadDeTrabajo.
	^self.
	! !

!UnidadDeTrabajoReal methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 9/16/2013 22:53'!
padre
	^ padre! !

Error subclass: #UnidadDeTrabajoException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes'!
